"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// we cannot import from 'ethers/utils` as this will run into a compile error in react-native
var ethers_1 = require("ethers");
var graphql_tag_1 = __importDefault(require("graphql-tag"));
var index_1 = require("../../index");
var PluginManagerPlugin = /** @class */ (function (_super) {
    __extends(PluginManagerPlugin, _super);
    function PluginManagerPlugin() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PluginManagerPlugin.initializeParamsMap = function (initParams) {
        Object.keys(initParams).forEach(function (key) {
            if (initParams[key] === undefined) {
                throw new Error("PluginManager's initialize parameter '" + key + "' cannot be undefined");
            }
        });
        return [
            initParams.daoId,
            initParams.votingMachine,
            initParams.votingParams,
            initParams.voteOnBehalf,
            initParams.voteParamsHash,
            initParams.daoFactory
        ];
    };
    PluginManagerPlugin.itemMap = function (context, item, queriedId) {
        if (!item) {
            index_1.Logger.debug("PluginManagerPlugin ItemMap failed.\n        " + (queriedId && "Could not find PluginManagerPlugin with id '" + queriedId + "'"));
            return null;
        }
        var baseState = index_1.Plugin.itemMapToBaseState(context, item);
        var schemeFactoryParams = item.schemeFactoryParams && {
            daoFactory: item.schemeFactoryParams.daoFactory,
            voteParams: index_1.mapGenesisProtocolParams(item.schemeFactoryParams.voteParams),
            votingMachine: item.schemeFactoryParams.votingMachine
        };
        return __assign(__assign({}, baseState), { pluginParams: schemeFactoryParams });
    };
    PluginManagerPlugin.prototype.createProposalTransaction = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var args, abiInterface, initializeParams, pluginData, pluginAddress, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        args = [];
                        if (options.add) {
                            abiInterface = void 0;
                            if (options.add.pluginName === 'Competition') {
                                abiInterface = new ethers_1.utils.Interface(this.context.getABI({
                                    abiName: 'ContributionRewardExt',
                                    version: index_1.LATEST_ARC_VERSION
                                }));
                            }
                            else {
                                abiInterface = new ethers_1.utils.Interface(this.context.getABI({
                                    abiName: options.add.pluginName,
                                    version: index_1.LATEST_ARC_VERSION
                                }));
                            }
                            initializeParams = index_1.Plugins[options.add.pluginName].initializeParamsMap(options.add.pluginInitParams);
                            pluginData = abiInterface.functions.initialize.encode(initializeParams);
                            args.push(index_1.PACKAGE_VERSION, options.add.pluginName === 'Competition' ? 'ContributionRewardExt' : options.add.pluginName, pluginData, options.add.permissions);
                        }
                        else {
                            args.push([0, 0, 0], '', '0x0', '0x00000000');
                        }
                        return [4 /*yield*/, this.fetchState()];
                    case 1:
                        pluginAddress = (_b.sent()).address;
                        if (!!options.descriptionHash) return [3 /*break*/, 3];
                        _a = options;
                        return [4 /*yield*/, this.context.saveIPFSData(options)];
                    case 2:
                        _a.descriptionHash = _b.sent();
                        _b.label = 3;
                    case 3: return [2 /*return*/, {
                            contract: this.context.getContract(pluginAddress),
                            method: 'proposeScheme',
                            args: __spreadArrays(args, [
                                options.remove ? options.remove.plugin : '0x0000000000000000000000000000000000000000',
                                options.descriptionHash
                            ])
                        }];
                }
            });
        });
    };
    PluginManagerPlugin.prototype.createProposalTransactionMap = function () {
        var _this = this;
        return function (receipt) { return __awaiter(_this, void 0, void 0, function () {
            var args, proposalId;
            return __generator(this, function (_a) {
                args = index_1.getEventArgs(receipt, 'NewSchemeProposal', 'PluginManager.createProposal');
                proposalId = args[1];
                return [2 /*return*/, new index_1.PluginManagerProposal(this.context, proposalId)];
            });
        }); };
    };
    PluginManagerPlugin.fragment = {
        name: 'PluginManagerParams',
        fragment: graphql_tag_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n      fragment PluginManagerParams on ControllerScheme {\n        schemeFactoryParams {\n          votingMachine\n          daoFactory\n          voteParams {\n            queuedVoteRequiredPercentage\n            queuedVotePeriodLimit\n            boostedVotePeriodLimit\n            preBoostedVotePeriodLimit\n            thresholdConst\n            limitExponentValue\n            quietEndingPeriod\n            proposingRepReward\n            votersReputationLossRatio\n            minimumDaoBounty\n            daoBountyConst\n            activationTime\n            voteOnBehalf\n          }\n        }\n      }\n    "], ["\n      fragment PluginManagerParams on ControllerScheme {\n        schemeFactoryParams {\n          votingMachine\n          daoFactory\n          voteParams {\n            queuedVoteRequiredPercentage\n            queuedVotePeriodLimit\n            boostedVotePeriodLimit\n            preBoostedVotePeriodLimit\n            thresholdConst\n            limitExponentValue\n            quietEndingPeriod\n            proposingRepReward\n            votersReputationLossRatio\n            minimumDaoBounty\n            daoBountyConst\n            activationTime\n            voteOnBehalf\n          }\n        }\n      }\n    "])))
    };
    return PluginManagerPlugin;
}(index_1.ProposalPlugin));
exports.PluginManagerPlugin = PluginManagerPlugin;
var templateObject_1;
//# sourceMappingURL=plugin.js.map