"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_tag_1 = __importDefault(require("graphql-tag"));
var index_1 = require("../../index");
var PluginRegistrarProposal = /** @class */ (function (_super) {
    __extends(PluginRegistrarProposal, _super);
    function PluginRegistrarProposal() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PluginRegistrarProposal.itemMap = function (context, item, queriedId) {
        if (!item) {
            index_1.Logger.debug("PluginRegistrarProposal ItemMap failed. " + (queriedId ? "Could not find PluginRegistrarProposal with id '" + queriedId + "'" : ''));
            return null;
        }
        var type;
        if (item.schemeRegistrar.schemeToRegister) {
            // TODO: this is failing bc of https://github.com/daostack/subgraph/issues/224
            type = 'SchemeRegistrarAdd';
        }
        else if (item.schemeRegistrar.schemeToRemove) {
            type = 'SchemeRegistrarRemove';
        }
        else {
            throw Error("Unknown proposal type: pluginRegistrar without a plugin to register or to remove");
        }
        var pluginRegistrarState = index_1.PluginRegistrarPlugin.itemMap(context, item.scheme, queriedId);
        if (!pluginRegistrarState) {
            return null;
        }
        var pluginRegistrar = new index_1.PluginRegistrarPlugin(context, pluginRegistrarState);
        var pluginRegistrarProposal = new PluginRegistrarProposal(context, item.id);
        var baseState = index_1.Proposal.itemMapToBaseState(context, item, pluginRegistrar, pluginRegistrarProposal, type);
        if (!baseState) {
            return null;
        }
        return __assign(__assign({}, baseState), { decision: item.schemeRegistrar.decision, pluginRegistered: item.schemeRegistrar.schemeRegistered, pluginRemoved: item.schemeRegistrar.schemeRemoved, pluginToRegister: item.schemeRegistrar.schemeToRegister, pluginToRegisterPermission: item.schemeRegistrar.schemeToRegisterPermission, pluginToRemove: item.schemeRegistrar.schemeToRemove });
    };
    PluginRegistrarProposal.prototype.state = function (apolloQueryOptions) {
        var query = graphql_tag_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["query ProposalState\n      {\n        proposal(id: \"", "\") {\n          ...ProposalFields\n          votes {\n            id\n          }\n          stakes {\n            id\n          }\n        }\n      }\n      ", "\n      ", "\n    "], ["query ProposalState\n      {\n        proposal(id: \"", "\") {\n          ...ProposalFields\n          votes {\n            id\n          }\n          stakes {\n            id\n          }\n        }\n      }\n      ", "\n      ", "\n    "])), this.id, index_1.Proposal.baseFragment, index_1.Plugin.baseFragment);
        return this.context.getObservableObject(this.context, query, PluginRegistrarProposal.itemMap, this.id, apolloQueryOptions);
    };
    PluginRegistrarProposal.fragment = {
        name: 'SchemeRegistrarProposalFields',
        fragment: graphql_tag_1.default(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n      fragment SchemeRegistrarProposalFields on Proposal {\n        schemeRegistrar {\n          id\n          schemeToRegister\n          schemeToRegisterPermission\n          schemeToRemove\n          decision\n          schemeRegistered\n          schemeRemoved\n        }\n      }\n    "], ["\n      fragment SchemeRegistrarProposalFields on Proposal {\n        schemeRegistrar {\n          id\n          schemeToRegister\n          schemeToRegisterPermission\n          schemeToRemove\n          decision\n          schemeRegistered\n          schemeRemoved\n        }\n      }\n    "])))
    };
    return PluginRegistrarProposal;
}(index_1.Proposal));
exports.PluginRegistrarProposal = PluginRegistrarProposal;
var templateObject_1, templateObject_2;
//# sourceMappingURL=proposal.js.map