import { Signer } from 'ethers';
import { AsyncSendable, JsonRpcProvider, Web3Provider as EthersWeb3JsProvider } from 'ethers/providers';
import { Observable } from 'rxjs';
import { IApolloQueryOptions } from '../index';
export declare type Address = string;
export declare type Date = number;
export declare type Hash = string;
export declare type Web3Provider = string | AsyncSendable | Signer;
export declare type Web3Client = JsonRpcProvider | EthersWeb3JsProvider;
export declare type IPFSProvider = string;
export interface IStateful<T> {
    state: (apolloQueryOptions: IApolloQueryOptions) => Observable<T>;
}
export interface ICommonQueryOptions {
    skip?: number;
    first?: number;
    orderBy?: string;
    orderDirection?: 'asc' | 'desc';
    where?: any;
}
